Loading...
Searching...
No Matches
juce::ChildProcess Class Reference

## Detailed Description

Launches and monitors a child process.

This class lets you launch an executable, and read its output. You can also use it to check whether the child process has finished.

The documentation for this class was generated from the following file:

- juce_core/threads/juce_ChildProcess.h

## Public Types

enum | StreamFlags { wantStdOut = 1 , wantStdErr = 2 }
| These flags are used by the start() methods. More...

## Public Member Functions

| ChildProcess ()
| Creates a process object.
| ~ChildProcess ()
| Destructor.
bool | start (const String &command, int streamFlags=wantStdOut|wantStdErr)
| Attempts to launch a child process command.
bool | start (const StringArray &arguments, int streamFlags=wantStdOut|wantStdErr)
| Attempts to launch a child process command.
bool | isRunning () const
| Returns true if the child process is alive.
int | readProcessOutput (void *destBuffer, int numBytesToRead)
| Attempts to read some output from the child process.
String | readAllProcessOutput ()
| Blocks until the process has finished, and then returns its complete output as a string.
bool | waitForProcessToFinish (int timeoutMs) const
| Blocks until the process is no longer running.
uint32 | getExitCode () const
| If the process has finished, this returns its exit code.
bool | kill ()
| Attempts to kill the child process.

## Member Enums

## StreamFlags

enum juce::ChildProcess::StreamFlags

These flags are used by the start() methods.

Enumerator
wantStdOut |
wantStdErr |

## Constructors and Destructors

## ChildProcess()

juce::ChildProcess::ChildProcess | ( |  | ) |

Creates a process object.

To actually launch the process, use start().

Referenced by kill().

## ~ChildProcess()

juce::ChildProcess::~ChildProcess | ( |  | ) |

Destructor.

Note that deleting this object won't terminate the child process.

## Member Functions

## start() [1/2]

bool juce::ChildProcess::start | ( | const String & | command,
|  | int | streamFlags = wantStdOut|wantStdErr )

Attempts to launch a child process command.

The command should be the name of the executable file, followed by any arguments that are required. If the process has already been launched, this will launch it again. If a problem occurs, the method will return false. The streamFlags is a combinations of values to indicate which of the child's output streams should be read and returned by readProcessOutput().

References command, wantStdErr, and wantStdOut.

## start() [2/2]

bool juce::ChildProcess::start | ( | const StringArray & | arguments,
|  | int | streamFlags = wantStdOut|wantStdErr )

Attempts to launch a child process command.

The first argument should be the name of the executable file, followed by any other arguments that are needed. If the process has already been launched, this will launch it again. If a problem occurs, the method will return false. The streamFlags is a combinations of values to indicate which of the child's output streams should be read and returned by readProcessOutput().

References wantStdErr, and wantStdOut.

## isRunning()

bool juce::ChildProcess::isRunning | ( |  | ) | const

Returns true if the child process is alive.

## readProcessOutput()

int juce::ChildProcess::readProcessOutput | ( | void * | destBuffer,
|  | int | numBytesToRead )

Attempts to read some output from the child process.

This will attempt to read up to the given number of bytes of data from the process. It returns the number of bytes that were actually read.

## readAllProcessOutput()

String juce::ChildProcess::readAllProcessOutput | ( |  | ) |

Blocks until the process has finished, and then returns its complete output as a string.

## waitForProcessToFinish()

bool juce::ChildProcess::waitForProcessToFinish | ( | int | timeoutMs | ) | const

Blocks until the process is no longer running.

## getExitCode()

uint32 juce::ChildProcess::getExitCode | ( |  | ) | const

If the process has finished, this returns its exit code.

## kill()

bool juce::ChildProcess::kill | ( |  | ) |

Attempts to kill the child process.

Returns true if it succeeded. Trying to read from the process after calling this may result in undefined behaviour.

References ChildProcess().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited